DECLARE SUB sd (t$)
DECLARE FUNCTION imgpixel2% (ppx%, ppy%) : CLS : SCREEN 13

filename$ = ""
palfilename$ = ""
autoload% = 0
palskipbyte% = 0

'                                 
'                                        
'                                          
'                                          
'                             
'                                        
'                                 
'                                freeware 1997 Milo Sedlacek (a.k.a. gradius)
'                                e-mail: sedlacek@execulink.com
'                                IRC: irc.sprynet.com #quickbasic
'

'Warranty disclaimer:
'
'The author of this program is not responsible for damages of any kind
'resulting from its use.
'
'QuickBasic is a registered trademark of Microsoft Corp.

'If you have any questions / comments concerning this product, contact me.
'Also if you find a bug I'd LOVE to hear from you.  If you happen to find
'a significant bug while using this program and tell me about it, I'll help
'you with your project.
'
'e-mail: sedlacek@execulink.com
'IRC: irc.sprynet.com #quickbasic nickname gradius

'Memory constants
CONST IMXWORDSIZE = 12288

'Colour constants
'Interface
CONST BORDERCOLOUR = 23
CONST BORDERCOLOUR2 = 23
CONST PANELCOLOUR = 24
CONST VOIDCOLOUR = 0
CONST WHITETEXTCOLOUR1 = 15
CONST BLACKTEXTCOLOUR1 = 1
CONST STATUSTEXTCOLOUR1 = 10
CONST REDTEXTCOLOUR1 = 12
CONST GREENTEXTCOLOUR1 = 10
CONST BLUETEXTCOLOUR1 = 9
CONST YELLOWTEXTCOLOUR1 = 14
CONST PAINTCURSORCOLOUR = 15
CONST PAINTCURSORCOLOUR2 = 0
CONST CURSORFLASHDELAY = 8
CONST MAXCOMMANDPAGE = 7

'Keyboard
CONST WAVEKEYERASECOLOUR = 0

DIM blowuprtn%(128)
DIM colorboxrtn%(128)
DIM SHARED font%(1728)
DIM SHARED fontwidth%(288)
DIM SHARED string13%(256)
DIM tempstring AS STRING * 80
DIM image%(2050)
DIM temp%(4100)
DIM SHARED temp2%(4100)
DIM temp3%(2050)
DIM pal%(512)
DIM decode%(128)
DIM stackx%(4800)
DIM stacky%(4800)
DIM imx%(IMXWORDSIZE)
DIM stackpointer%
DIM SHARED xsize%, ysize%
DIM movememrtn%(256)
DIM memfillrtn%(128)
DIM SHARED x%, y%, c1%, c2%

IF palfilename$ = "" THEN palfilename$ = "(default)"
IF filename$ = "" THEN filename$ = " "

'Image info variables
xsize% = 10
ysize% = 10

'Initial variables
colour% = 10
ecolour% = 0
frame% = 0
totalframes% = 0
filemode% = 0         '0 = img,  1 = imx
filenameupdown% = 0
commandpage% = 0
imx%(0) = 1
imx%(8) = 9

'Delay message variables
CONST DELAYMESSAGEORIGINALCOUNTDOWN = 16
delaymessagecountdown% = 0
delaymessage$ = ""

'Initialize stuff
GOSUB initvariables
GOSUB readdata
GOSUB getwindowxy
GOSUB getpixelsize
GOSUB getimage

GOSUB saveold

'Cursor variables
cursorx% = xsize% \ 2
cursory% = ysize% \ 2

GOSUB loadpalette

GOSUB findfilemode
GOSUB drawscreen
GOSUB numlockoncapslockoff
GOSUB findfilemode2
GOSUB drawframeword
IF autoload% = 1 THEN GOSUB loadbitmap
IF filemode% = 1 THEN GOSUB drawstatusframe

GOSUB updatecursor

DO
  DO
    IF a$ <> "" THEN GOSUB keytest
    a$ = INKEY$
    DEF SEG = 0: ab% = PEEK(1047): DEF SEG
    WAIT &H3DA, 8
    WAIT &H3DA, 8, 8
    GOSUB dodelaymessage
    GOSUB altdraw
  LOOP UNTIL a$ = CHR$(27)
  t$ = "exit? ESC = yes": GOSUB showmessage
  DO: a$ = INKEY$: LOOP UNTIL a$ <> ""
  t$ = "exit? ESC = yes": GOSUB clearmessage
LOOP UNTIL a$ = CHR$(27)

SYSTEM

keytest:
GOSUB saveold

paintcursormovedelta% = 1
IF (ab% AND 3) > 0 THEN paintcursormovedelta% = 5
redrawpaintcursorflag% = 0
noautoline% = 0
updatergbflag% = 0

SELECT CASE a$
CASE CHR$(0) + CHR$(72)
  IF (cursory% = ysize% - 1) AND ((ab% AND 3) > 0) AND (ysize% > 1) THEN
    GOSUB deleterow
  ELSE
    IF cursory% > 0 THEN
      cursory% = cursory% - paintcursormovedelta%
    ELSE
      IF (ab% AND 3) > 0 THEN GOSUB expandborderup
    END IF
  END IF
CASE CHR$(0) + CHR$(77)
  IF (cursorx% = 0) AND ((ab% AND 3) > 0) AND (xsize% > 1) THEN
    GOSUB deletecolumn
  ELSE
    IF cursorx% < xsize% - 1 THEN
      cursorx% = cursorx% + paintcursormovedelta%
    ELSE
      IF (ab% AND 3) > 0 THEN GOSUB expandborderright
    END IF
  END IF
CASE CHR$(0) + CHR$(80)
  IF (cursory% = 0) AND ((ab% AND 3) > 0) AND (ysize% > 1) THEN
    GOSUB deleterow
  ELSE
    IF cursory% < ysize% - 1 THEN
      cursory% = cursory% + paintcursormovedelta%
    ELSE
      IF (ab% AND 3) > 0 THEN GOSUB expandborderdown
    END IF
  END IF
CASE CHR$(0) + CHR$(75)
  IF (cursorx% = xsize% - 1) AND ((ab% AND 3) > 0) AND (xsize% > 1) THEN
    GOSUB deletecolumn
  ELSE
    IF cursorx% > 0 THEN
      cursorx% = cursorx% - paintcursormovedelta%
    ELSE
      IF (ab% AND 3) > 0 THEN GOSUB expandborderleft
    END IF
  END IF
CASE CHR$(0) + CHR$(71)   'Home
  IF (ab% AND 3) = 0 THEN
    cursorx% = 0
  ELSE
    cursory% = 0
  END IF
CASE CHR$(0) + CHR$(79)   'End
  IF (ab% AND 3) = 0 THEN
    cursorx% = xsize% - 1
  ELSE
    cursory% = ysize% - 1
  END IF
CASE CHR$(0) + CHR$(119)  'Ctrl + Home
  noautoline% = 1
  cursory% = 0
  IF (ab% AND 3) = 0 THEN
    cursorx% = 0
  ELSE
    cursorx% = xsize% - 1
  END IF
CASE CHR$(0) + CHR$(117)  'Ctrl + End
  noautoline% = 1
  cursory% = ysize% - 1
  IF (ab% AND 3) = 0 THEN
    cursorx% = xsize% - 1
  ELSE
    cursorx% = 0
  END IF
CASE "x": SWAP colour%, ecolour%
CASE "X": ecolour% = colour%
CASE " ", "b"
  c% = colour%
  GOSUB drawpixel
  redrawpaintcursorflag% = 1
CASE "e"
  c% = ecolour%
  GOSUB drawpixel
  redrawpaintcursorflag% = 1
CASE "`"
  c% = WAVEKEYERASECOLOUR
  GOSUB drawpixel
  redrawpaintcursorflag% = 1
CASE CHR$(0) + CHR$(83)
  IF (ab% AND 3) = 0 THEN
    GOSUB deletecolumn
  ELSE
    GOSUB deleterow
  END IF
CASE CHR$(0) + CHR$(82)
  IF (ab% AND 3) = 0 THEN
    GOSUB insertcolumn
  ELSE
    GOSUB insertrow
  END IF
CASE "a": auto% = auto% XOR 1
CASE "q": auto% = 0
CASE "/": GOSUB gotocolour
CASE "?": GOSUB gotoecolour
CASE "7": red% = red% - 1: updatergbflag% = 1
CASE "9": red% = red% + 1: updatergbflag% = 1
CASE "4": green% = green% - 1: updatergbflag% = 1
CASE "6": green% = green% + 1: updatergbflag% = 1
CASE "1": blue% = blue% - 1: updatergbflag% = 1
CASE "3": blue% = blue% + 1: updatergbflag% = 1
CASE "2": GOSUB darkencolour: updatergbflag% = 1
CASE "8": GOSUB lightencolour: updatergbflag% = 1
CASE "5": GOSUB setspread
CASE "\": GOSUB slashsize
CASE "z": GOSUB changexysize
CASE "]": inc% = 1: GOSUB coloursadjust
CASE "[": inc% = -1: GOSUB coloursadjust
CASE "}": inc% = 16: GOSUB coloursadjust
CASE "{": inc% = -16: GOSUB coloursadjust
CASE "f"
  filepickmode% = 0
  GOSUB pickfile
CASE "s"
  filepickmode% = 1
  GOSUB pickfile
CASE "l"
  filepickmode% = 2
  GOSUB pickfile
CASE "r"
  GOSUB flipx
CASE "R"
  IF (ab% AND 3) = 2 THEN
    GOSUB flipy
  ELSE
    GOSUB rotate90
  END IF
CASE "d": GOSUB adjustframe
CASE "c": GOSUB copy
CASE "C": GOSUB colours
CASE "i": GOSUB paste
CASE "I"
  IF (ab% AND 3) = 1 THEN
    GOSUB pasteunder
  ELSE
    GOSUB pasteover
  END IF
CASE "n", "w": GOSUB nfunction
CASE "N": GOSUB clearframe
CASE "F": GOSUB floodfill
CASE "p": GOSUB qbpaint
CASE CHR$(0) + CHR$(59): GOSUB nextcommandpage
CASE CHR$(0) + CHR$(84): GOSUB previouscommandpage
CASE "o": GOSUB outline
CASE "m": GOSUB makemask
END SELECT

GOSUB colourcontrol

IF filemode% = 1 THEN
  SELECT CASE a$
  CASE CHR$(0) + CHR$(73)
    IF (ab% AND 3) = 0 THEN
      inc% = 1
      GOSUB framechange
    ELSE
      inc% = 5
      GOSUB framechange
    END IF
  CASE CHR$(0) + CHR$(81)
    IF (ab% AND 3) = 0 THEN
      inc% = -1
      GOSUB framechange
    ELSE
      inc% = -5
      GOSUB framechange
    END IF
  CASE CHR$(0) + CHR$(132)
    frame% = 0
    inc% = 0
    GOSUB framechange
  CASE CHR$(0) + CHR$(118)
    frame% = totalframes%
    inc% = 0
    GOSUB framechange
  CASE CHR$(0) + CHR$(63): inc% = 1: GOSUB addframe
  CASE CHR$(0) + CHR$(88): inc% = 0: GOSUB addframe
  CASE CHR$(0) + CHR$(64): GOSUB delframe
  END SELECT
END IF

GOSUB dolimits

IF auto% = 1 THEN GOSUB autodraw

GOSUB updatescreen
RETURN

updatescreen:
GOSUB updatecursor
GOSUB updatecolourcursor
GOSUB updateauto
GOSUB updatestatus
IF updatergbflag% = 1 THEN c% = colour%: GOSUB changergb: GOSUB updatergb
GOSUB redrawmemwordstatus
RETURN

dolimits:
GOSUB docursorlimits
GOSUB docolourlimits
GOSUB dorgblimits
RETURN

readdata:
DEF SEG = VARSEG(decode%(0)): RESTORE decodedata: GOSUB readit
psegment& = VARSEG(blowuprtn%(0)): RESTORE ex13rtndata: GOSUB readit2
psegment& = VARSEG(colorboxrtn%(0)): RESTORE colorboxrtndata: GOSUB readit2
psegment& = VARSEG(font%(0)): RESTORE tinyfontdata: GOSUB readit2
psegment& = VARSEG(fontwidth%(0)): RESTORE tinywidthdata: GOSUB readit2
psegment& = VARSEG(string13%(0)): RESTORE sd13rtndata: GOSUB readit2
psegment& = VARSEG(movememrtn%(0)): RESTORE movememrtndata: GOSUB readit2
psegment& = VARSEG(memfillrtn%(0)): RESTORE memfillrtndata: GOSUB readit2
GOSUB readdefaultpalette
RETURN

readdefaultpalette:
DEF SEG = VARSEG(decode%(0)): RESTORE decodedata: GOSUB readit
psegment& = VARSEG(pal%(0)): RESTORE defaultpalettedata: GOSUB readit2
RETURN

readit:
i& = 0
GOTO readitSKIP0
DO
  POKE i&, q%
  i& = i& + 1
readitSKIP0:
  READ q%
LOOP WHILE q% <> -1
RETURN

readit2:
i& = 0
GOTO readit2SKIP0
DO
  DEF SEG = VARSEG(decode%(0))
  CALL absolute(psegment&, i&, VARSEG(tempstring), VARPTR(tempstring), 9, 0)
  DEF SEG
  i& = i& + 63
readit2SKIP0:
  READ tempstring
LOOP UNTIL LEFT$(tempstring, 2) = "-1"
RETURN

blowup:
GOSUB drawimageborder
x& = 320 - xsize%
y& = 200 - ysize%
sourceoffset& = y& * 320 + x&
destinationoffset& = 0
xsize1% = xsize%
ysize1% = ysize%
DEF SEG = VARSEG(blowuprtn%(0))
CALL absolute(sourceoffset&, destinationoffset&, pixelxsize%, pixelysize%, xsize1%, ysize1%, &H0)
DEF SEG
redrawpaintcursorflag% = 1
RETURN

getpixelsize:
pixelxsize% = 256 \ xsize%
pixelysize% = 136 \ ysize%
IF pixelxsize% < pixelysize% THEN pixelysize% = pixelxsize%
IF pixelysize% < pixelxsize% THEN pixelxsize% = pixelysize%
RETURN

drawscreen:
GOSUB drawtinyborder
GOSUB drawcommandpage
GOSUB drawstatusareanormal
GOSUB drawpanelborders
GOSUB drawimageborder
GOSUB drawcolourarea
GOSUB blowup
GOSUB drawallcursors
GOSUB drawstatusarea
RETURN

'Draw border around tiny window
drawtinyborder:
x% = 320 - xsize% - 1
y% = 200 - ysize% - 1
IF ysize% < 64 THEN
  LINE (320 - xsize%, y%)-(320, y%), BORDERCOLOUR2
  IF ysize% < 63 THEN
    LINE (320 - xsize%, 200 - ysize% - 2)-(320, 136), VOIDCOLOUR, BF
  END IF
END IF
IF xsize% < 64 THEN
  LINE (x%, 200 - ysize%)-(x%, 200), BORDERCOLOUR2
  IF xsize% < 63 THEN
    LINE (320 - xsize% - 2, 200 - ysize%)-(256, 200), VOIDCOLOUR, BF
  END IF
END IF
IF xsize% < 64 AND ysize% < 64 THEN
  LINE (256, 136)-(x%, y%), VOIDCOLOUR, BF
  PSET (x%, y%), BORDERCOLOUR2
END IF
RETURN

'DATA

'7 bit decoder
decodedata:
DATA 85,137,229,80,83,81,82,30,86,6,87,190,6,0,177,5,54,139,26,139
DATA 7,54,137,2,70,70,254,201,117,242,54,142,94,10,54,139,118,8,54,142
DATA 70,14,54,139,126,12,87,186,7,0,54,139,70,6,247,226,137,193,176,0
DATA 243,170,95,177,0,54,139,86,6,172,180,0,36,127,211,224,209,224,38,8
DATA 101,255,38,8,5,71,254,193,128,225,7,117,232,79,74,117,228,95,7,94
DATA 31,90,89,91,88,137,236,93,202,10,0,0,-1

'Assembly language window blowup routine
ex13rtndata:
DATA ѩ㴬ѐݾ؃쐛틿،ŕض
DATA ř耉松坼ڔ慠̺ǯ۬
DATA -1

'Assembly language string display routine
sd13rtndata:
DATA ϖЩԪ،߁틍󴤄ƣٗУ؋Ҁ￈
DATA ڜދѷ틫Ҙуڀã𴼀샻
DATA 𘌶ǑچÕЍе؆ɺМ੧杼٦
DATA Ȥ¡Ȥữݿ𼰔޺
DATA À
DATA -1

'Assembly language routine to draw a 16x16 colour matrix
colorboxrtndata:
DATA Ղ͢ҏꖇɺ׀ݐѵۄݮ
DATA ř耉松٧ř莝٭֑
DATA -1

'Tiny font drawn by Lukas Sedlacek
tinyfontdata:
DATA 
DATA 𸜄
DATA 𐀀𸈀𸀀ࠀ
DATA 𐜀
DATA 
DATA ࠀ
DATA 𸀀
DATA 
DATA 
DATA 𐀀
DATA 𐀀
DATA ࠀ
DATA 𸈀
DATA 𸀀
DATA 𸀀
DATA 
DATA 
DATA 𸈀ࠀ
DATA 
DATA 𸜀𐀀
DATA ࠀ
DATA 𸀀𸜀
DATA 
DATA 𸜀𸀀
DATA 
DATA 𐀄𐜎
DATA 𸈎
DATA 𐀀𸈀
DATA ࠀ
DATA 𸀀𸜀
DATA 
DATA 𐀀
DATA 
DATA 𸀀𸀀
DATA 
DATA 
DATA 𸜎
DATA 𐀀
DATA 
DATA 𸀀𸀀
DATA 
DATA 𸀀ࠀ
DATA 𸀀
DATA 𸀀
DATA 
DATA ࠀ𐀀
DATA 
DATA 𐀀
DATA 
DATA 𐜀
DATA 𐀀
DATA 𸈀𸀀
DATA 
DATA 
DATA 𐀀
DATA -1

'Widths for tiny font by Lukas Sedlacek
tinywidthdata:
DATA ఘఘనఘఐ
DATA ఈఘన
DATA -1

'Default palette by Ryan Ross
defaultpalettedata:
DATA šԪ ̿Шظ
DATA ĢШ¡Ш˥ӑ东Ѐ
DATA ЀȀ
DATA ఀڭƠ
DATA 耀ج
DATA 䲀ȸ踲
DATA ǇЈ𨸔áȔʢ㑸
DATA 񀀐ƠȔѰ𠸏р
DATA  ̚ŁԖ񉸰䞱Ħ柊̈́ƙل
DATA ֿˢ䬓Ƃ謠ȠȟĒƯ殔
DATA ĠజȤɴܮ؜
DATA 𰜐Ȩɸ䮚Ј𸸔áѠȤ
DATA ʥܷ쀀
DATA -1

'Assembly language routine to move memory around
movememrtndata:
DATA ؟ЩԪ،߁틍󴤄ƣٗȬ݀ژ𴺭䏤
DATA ڞǥ𴺭ҁȁѕ퀈󶀎ֈҺ
DATA 䩭З̀ő蝠ء̀ȁѥк
DATA 䰪΃ѷഹǗ߃Ш
DATA -1

'Assembly langage routine to fill an area of memory with a value
memfillrtndata:
DATA Ղ͢ҏꖇɺôڔƄѴ窯۬
DATA -1

drawstatusareanormal:
LINE (257, 67)-(318, 134), PANELCOLOUR, BF
RETURN

drawimageborder:
x% = xsize% * pixelxsize%
y% = ysize% * pixelysize%
IF x% < 256 THEN
  IF y% > 135 THEN y% = 135
  LINE (x%, 0)-(x%, y%), BORDERCOLOUR2
  IF x% < 255 THEN LINE (x% + 1, 0)-(255, y%), VOIDCOLOUR, BF
END IF
IF y% < 136 THEN
  IF x% > 255 THEN x% = 255
  LINE (0, y%)-(x%, y%), BORDERCOLOUR2
  IF y% < 135 THEN LINE (0, y% + 1)-(255, 135), VOIDCOLOUR, BF
END IF
RETURN

drawcolourarea:
LINE (256, 0)-(319, 68), BORDERCOLOUR, B
LINE (257, 1)-(318, 67), PANELCOLOUR, BF
LINE (270, 0)-(270, 68), BORDERCOLOUR
LINE (256, 49)-(319, 49), BORDERCOLOUR
LINE (256, 25)-(270, 25), BORDERCOLOUR
GOSUB drawcolourbox
GOSUB updatecolourboxes
GOSUB drawrgbletters
GOSUB drawrgbbars
RETURN

drawstatusarea:
t$ = "x:"
x% = 258
y% = 69
c1% = STATUSTEXTCOLOUR1
GOSUB stringdisplay

t$ = "y:": y% = y% + 6: GOSUB stringdisplay
t$ = "xsize:": y% = y% + 6: GOSUB stringdisplay
t$ = "ysize:": y% = y% + 6: GOSUB stringdisplay
t$ = "file:": y% = y% + 12: GOSUB stringdisplay
GOSUB redrawpalettewordstatus
GOSUB redrawmemwordstatus
GOSUB drawallstatus
RETURN

drawframeword:
IF filemode% = 1 THEN
  t$ = "frame:"
  x% = 258
  y% = 93
  c1% = STATUSTEXTCOLOUR1
  GOSUB stringdisplay
END IF
RETURN

drawcolourbox:
DEF SEG = VARSEG(colorboxrtn%(0))
CALL absolute(271, 1, 3, 3, 0)
DEF SEG
RETURN

updatecolourboxes:
LINE (257, 1)-(269, 24), colour%, BF
LINE (257, 26)-(269, 48), ecolour%, BF
t$ = MID$(STR$(colour%), 2, LEN(STR$(colour%)) - 1)
x% = 258
y% = 10
GOSUB updatecolourboxesCHOOSECOLOUR1
GOSUB stringdisplay
t$ = MID$(STR$(ecolour%), 2, LEN(STR$(ecolour%)) - 1)
y% = 35
GOSUB updatecolourboxesCHOOSECOLOUR2
GOSUB stringdisplay
GOSUB updatergb
RETURN

updatecolourboxesCHOOSECOLOUR1:
c% = colour%
GOSUB updatecolourboxesCHOOSESETCOLOUR
RETURN

updatecolourboxesCHOOSECOLOUR2:
c% = ecolour%
GOSUB updatecolourboxesCHOOSESETCOLOUR
RETURN

updatecolourboxesCHOOSESETCOLOUR:
GOSUB choosecursordrawcolour
IF c% = PAINTCURSORCOLOUR THEN
  c1% = WHITETEXTCOLOUR1
ELSE
  c1% = BLACKTEXTCOLOUR1
END IF
RETURN

stringdisplay:
IF t$ = "" THEN RETURN
tempstring = t$
tempstringlength% = LEN(t$)
DEF SEG = VARSEG(string13%(0))
CALL absolute(1, VARSEG(font%(0)), VARPTR(font%(0)), VARSEG(tempstring), VARPTR(tempstring), tempstringlength%, x%, y%, c1%, 0, VARSEG(fontwidth%(0)), VARPTR(fontwidth%(0)), &H10)
DEF SEG
RETURN

drawrgbletters:
t$ = "r"
x% = 258
y% = 50
c1% = REDTEXTCOLOUR1
GOSUB stringdisplay
t$ = "g"
y% = 55
c1% = GREENTEXTCOLOUR1
GOSUB stringdisplay
t$ = "b"
y% = 62
c1% = BLUETEXTCOLOUR1
GOSUB stringdisplay
RETURN

updatergb:
OUT &H3C7, colour%
red% = INP(&H3C9)
green% = INP(&H3C9)
blue% = INP(&H3C9)
GOSUB updatergbscreen
RETURN

updatergbscreen:
GOSUB updatergbnumbers
GOSUB updatergbbars
RETURN

updatergbnumbers:
LINE (263, 50)-(269, 67), PANELCOLOUR, BF
t$ = MID$(STR$(red%), 2, LEN(STR$(red%)) - 1)
x% = 263
y% = 50
c1% = REDTEXTCOLOUR1
GOSUB stringdisplay
t$ = MID$(STR$(green%), 2, LEN(STR$(green%)) - 1)
y% = 56
c1% = GREENTEXTCOLOUR1
GOSUB stringdisplay
t$ = MID$(STR$(blue%), 2, LEN(STR$(blue%)) - 1)
y% = 62
c1% = BLUETEXTCOLOUR1
GOSUB stringdisplay
RETURN

updatergbbars:
GOSUB erasergbindicators
GOSUB drawrgbindicators:
RETURN

saveold:
oldcursorx% = cursorx%
oldcursory% = cursory%
oldcolour% = colour%
oldecolour% = ecolour%
oldauto% = auto%
GOSUB saveoldsubs
oldfilename$ = filename$
oldpalfilename$ = palfilename$
oldred% = red%
oldgreen% = green%
oldblue% = blue%
oldfilemode% = filemode%
oldframe% = frame%
oldtotalframes% = totalframes%
RETURN


erasepaintcursor:
x% = oldcursorx%
y% = oldcursory%
GOSUB replaceimagepixel
RETURN

drawpaintcursor:
x% = cursorx%
y% = cursory%
GOSUB getimgcolour
GOSUB choosecursordrawcolour
PSET (windowx% + cursorx%, windowy% + cursory%), c%
x% = cursorx% * pixelxsize%
y% = cursory% * pixelysize%
LINE (x%, y%)-(x% + pixelxsize% - 1, y% + pixelysize% - 1), c%, B
RETURN

getwindowxy:
windowx% = 320 - xsize%
windowy% = 200 - ysize%
RETURN

drawallcursors:
GOSUB drawpaintcursor
GOSUB drawcolorcursor
RETURN

replaceimagepixel:
DEF SEG = VARSEG(image%(0))
c% = PEEK(y% * xsize% + x% + 4)
DEF SEG
PSET (windowx% + x%, windowy% + y%), c%
LINE (x% * pixelxsize%, y% * pixelysize%)-(x% * pixelxsize% + pixelxsize% - 1, y% * pixelysize% + pixelysize% - 1), c%, BF
RETURN

updatecursor:
IF (cursorx% <> oldcursorx%) OR (cursory% <> oldcursory%) OR (redrawpaintcursorflag% = 1) THEN
  IF (oldcursorx% < xsize%) AND (oldcursory% < ysize%) THEN GOSUB erasepaintcursor
  GOSUB drawpaintcursor
END IF
RETURN

docursorlimits:
IF cursorx% < 0 THEN cursorx% = 0
IF cursory% < 0 THEN cursory% = 0
IF cursorx% > xsize% - 1 THEN cursorx% = xsize% - 1
IF cursory% > ysize% - 1 THEN cursory% = ysize% - 1
RETURN

getimage:
GET (windowx%, windowy%)-(319, 199), image%
RETURN

getimgcolour:
DEF SEG = VARSEG(image%(0))
c% = PEEK(y% * xsize% + x% + 4)
DEF SEG
RETURN

choosecursordrawcolour:
OUT &H3C7, c%
r% = INP(&H3C9)
g% = INP(&H3C9)
b% = INP(&H3C9)
L% = r%
IF g% > L% THEN L% = g%
IF b% > L% THEN L% = b%
IF L% < 48 THEN
  c% = PAINTCURSORCOLOUR
ELSE
  c% = PAINTCURSORCOLOUR2
END IF
RETURN

docolourlimits:
colour% = colour% AND 255
ecolour% = ecolour% AND 255
RETURN

updatecolourcursor:
IF (colour% <> oldcolour%) OR (ecolour% <> oldecolour%) THEN
  GOSUB updatecolourboxes
  GOSUB erasecolorcursor
  GOSUB drawcolorcursor
END IF
RETURN

numlockoncapslockoff:
DEF SEG = 0
POKE 1047, PEEK(1047) AND (255 - 64)    'Turn off caps lock
POKE 1047, PEEK(1047) OR 32             'Turn on num lock
DEF SEG
RETURN

erasecolorcursor:
x% = ((oldcolour% AND 15) * 3) + 271
y% = ((oldcolour% \ 16) * 3) + 1
LINE (x%, y%)-(x% + 2, y% + 2), oldcolour%, B
RETURN

drawcolorcursor:
x% = ((colour% AND 15) * 3) + 271
y% = ((colour% \ 16) * 3) + 1
c% = colour%
GOSUB choosecursordrawcolour
LINE (x%, y%)-(x% + 2, y% + 2), c%, B
RETURN

drawpixel:
PSET (windowx% + cursorx%, windowy% + cursory%), c%
x% = cursorx% * pixelxsize%
y% = cursory% * pixelysize%
LINE (x%, y%)-(x% + pixelxsize% - 1, y% + pixelysize% - 1), c%, BF
x% = cursorx%
y% = cursory%
GOSUB imgsetpixel
RETURN

imgsetpixel:
DEF SEG = VARSEG(image%(0))
POKE (y% * xsize% + x% + 4), c%
DEF SEG
RETURN

updateauto:
IF (oldauto% <> auto%) THEN
  t$ = "auto"
  x% = 303
  y% = 69
  IF auto% = 0 THEN
    c1% = PANELCOLOUR
  ELSE
    c1% = BLUETEXTCOLOUR1
  END IF
  GOSUB stringdisplay
END IF
RETURN

autodraw:
redrawpaintcursorflag% = 1
IF noautoline% = 0 THEN
  LINE (cursorx% + windowx%, cursory% + windowy%)-(oldcursorx% + windowx%, oldcursory% + windowy%), colour%
  GOSUB getimage
  GOSUB blowup
ELSE
  c% = colour%
  GOSUB drawpixel
END IF
RETURN

gotocolour:
x% = cursorx%
y% = cursory%
GOSUB getimgcolour
colour% = c%
RETURN

gotoecolour:
x% = cursorx%
y% = cursory%
GOSUB getimgcolour
ecolour% = c%
RETURN

drawallstatus:
GOSUB drawstatusxy
GOSUB drawstatusxysize
GOSUB drawstatusfilename
GOSUB drawstatuspalfilename
RETURN

setpalette:
DEF SEG = VARSEG(pal%(0))
i& = 0
FOR c% = 0 TO 255
  OUT &H3C8, c%
  r% = PEEK(i&)
  g% = PEEK(i& + 1)
  b% = PEEK(i& + 2)
  OUT &H3C9, r%
  OUT &H3C9, g%
  OUT &H3C9, b%
  i& = i& + 3 + palskipbyte%
NEXT
DEF SEG
RETURN

drawstatusxy:
t$ = MID$(STR$(cursorx%), 2, LEN(STR$(cursorx%)) - 1)
x% = 282
y% = 69
c1% = STATUSTEXTCOLOUR1
GOSUB stringdisplay
t$ = MID$(STR$(cursory%), 2, LEN(STR$(cursory%)) - 1)
y% = y% + 6
GOSUB stringdisplay
RETURN

drawstatusxysize:
t$ = MID$(STR$(xsize%), 2, LEN(STR$(xsize%)) - 1)
x% = 282
y% = 69 + 12
c1% = STATUSTEXTCOLOUR1
GOSUB stringdisplay
t$ = MID$(STR$(ysize%), 2, LEN(STR$(ysize%)) - 1)
y% = y% + 6
GOSUB stringdisplay
RETURN

loadpalette:
IF palfilename$ = "(default)" THEN
  GOSUB readdefaultpalette
ELSE
  DEF SEG = VARSEG(pal%(0))
  BLOAD palfilename$, 0
  DEF SEG
END IF
GOSUB setpalette
RETURN

drawstatusframe:
t$ = "frame:"
x% = 258
y% = 93
c1% = STATUSTEXTCOLOUR1
GOSUB stringdisplay

t$ = MID$(STR$(frame% + 1), 2, LEN(STR$(frame% + 1)) - 1)
t$ = t$ + "/" + MID$(STR$(totalframes% + 1), 2, LEN(STR$(totalframes% + 1)) - 1)
x% = 282
GOSUB stringdisplay
RETURN

drawstatusfilename:
t$ = filename$
x% = 258
y% = 69 + 36
c1% = BLUETEXTCOLOUR1
GOSUB stringdisplay
RETURN

drawstatuspalfilename:
t$ = palfilename$
x% = 258
y% = 117
c1% = BLUETEXTCOLOUR1
GOSUB stringdisplay
RETURN

updatestatus:
GOSUB updatexy
GOSUB updatexysize
GOSUB updateframe
GOSUB updatefilename
GOSUB updatepalfilename
RETURN

updatexy:
IF (cursorx% <> oldcursorx%) OR (cursory% <> oldcursory%) THEN
  GOSUB erasestatusxy
  GOSUB drawstatusxy
END IF
RETURN

updatexysize:
IF (xsize% <> oldxsize%) OR (ysize% <> oldysize%) THEN
  GOSUB erasestatusxysize
  GOSUB drawstatusxysize
  GOSUB drawtinyborder
END IF
RETURN

updatexysizenoborder:
IF (xsize% <> oldxsize%) OR (ysize% <> oldysize%) THEN
  GOSUB erasestatusxysize
  GOSUB drawstatusxysize
END IF
RETURN

updateframe:
IF filemode% = 1 THEN
  IF (oldframe% <> frame%) OR (oldtotalframes% <> totalframes%) OR (oldfilemode% = 0) THEN
    GOSUB erasestatusframe
    GOSUB drawstatusframe
  END IF
ELSE
  IF oldfilemode% = 1 THEN
    GOSUB erasestatusframe
  END IF
END IF
RETURN

updatefilename:
RETURN

updatepalfilename:
RETURN

erasestatusxy:
t$ = MID$(STR$(oldcursorx%), 2, LEN(STR$(oldcursorx%)) - 1)
x% = 282
y% = 69
c1% = PANELCOLOUR
GOSUB stringdisplay
t$ = MID$(STR$(oldcursory%), 2, LEN(STR$(oldcursory%)) - 1)
y% = y% + 6
GOSUB stringdisplay
RETURN

erasestatusxysize:
t$ = MID$(STR$(oldxsize%), 2, LEN(STR$(oldxsize%)) - 1)
x% = 282
y% = 69 + 12
c1% = PANELCOLOUR
GOSUB stringdisplay
t$ = MID$(STR$(oldysize%), 2, LEN(STR$(oldysize%)) - 1)
y% = y% + 6
GOSUB stringdisplay
RETURN

drawrgbbars:
LINE (272, 53)-(317, 53), BORDERCOLOUR
LINE (272, 58)-(317, 58), BORDERCOLOUR
LINE (272, 64)-(317, 64), BORDERCOLOUR
RETURN

drawrgbindicators:
x% = (46 / 64) * red%
LINE (272 + x%, 52)-(272 + x%, 54), BORDERCOLOUR
x% = (46 / 64) * green%
LINE (272 + x%, 57)-(272 + x%, 59), BORDERCOLOUR
x% = (46 / 64) * blue%
LINE (272 + x%, 63)-(272 + x%, 65), BORDERCOLOUR
RETURN

erasergbindicators:
x% = (46 / 64) * oldred%
LINE (272 + x%, 52)-(272 + x%, 54), PANELCOLOUR
PSET (272 + x%, 53), BORDERCOLOUR
x% = (46 / 64) * oldgreen%
LINE (272 + x%, 57)-(272 + x%, 59), PANELCOLOUR
PSET (272 + x%, 58), BORDERCOLOUR
x% = (46 / 64) * oldblue%
LINE (272 + x%, 63)-(272 + x%, 65), PANELCOLOUR
PSET (272 + x%, 64), BORDERCOLOUR
RETURN

dorgblimits:
red% = red% AND 63
green% = green% AND 63
blue% = blue% AND 63
RETURN

changergb:
DEF SEG = VARSEG(pal%(0))
i& = c% * (3 + palskipbyte%)
POKE i&, red%
POKE i& + 1, green%
POKE i& + 2, blue%
DEF SEG
OUT &H3C8, c%
OUT &H3C9, red%
OUT &H3C9, green%
OUT &H3C9, blue%
RETURN

expandborderup:
GOSUB erasepaintcursor
ysize% = ysize% + 1
GOSUB expandgeneral
IF flag% = 0 THEN GOSUB blanklinetop
GOSUB expandgeneral2
RETURN

expandborderright:
GOSUB erasepaintcursor
xsize% = xsize% + 1
cursorx% = cursorx% + 1
GOSUB expandgeneral
PUT (windowx%, windowy%), image%, PSET
IF flag% = 0 THEN GOSUB blanklineright
GOSUB expandgeneral2
RETURN

expandborderdown:
GOSUB erasepaintcursor
ysize% = ysize% + 1
cursory% = cursory% + 1
GOSUB expandgeneral
PUT (windowx%, windowy%), image%, PSET
IF flag% = 0 THEN GOSUB blanklinedown
GOSUB expandgeneral2
RETURN

expandborderleft:
GOSUB erasepaintcursor
xsize% = xsize% + 1
GOSUB expandgeneral
IF flag% = 0 THEN GOSUB blanklineleft
GOSUB expandgeneral2
RETURN

xysizelimits:
flag% = 0
IF xsize% < 1 THEN xsize% = 1: flag% = 1
IF ysize% < 1 THEN ysize% = 1: flag% = 1
IF xsize% > 64 THEN xsize% = 64: flag% = 1
IF ysize% > 64 THEN ysize% = 64: flag% = 1
RETURN

blanklinetop:
LINE (windowx%, windowy%)-(319, windowy%), 0
RETURN

blanklineleft:
LINE (windowx%, windowy%)-(windowx%, 199), 0
RETURN

blanklineright:
LINE (319, windowy%)-(319, 199), 0
RETURN

blanklinedown:
LINE (windowx%, 199)-(319, 199), 0
RETURN

expandgeneral:
GOSUB xysizelimits
GOSUB getwindowxy
GOSUB getpixelsize
RETURN

expandgeneral2:
GOSUB getimage
GOSUB blowup
RETURN

slashsize:
GOSUB erasepaintcursor

x1% = windowx%
x2% = windowx%
y1% = windowy%
y2% = windowy%

FOR x% = windowx% TO 319
  FOR y% = windowy% TO 199
    IF POINT(x%, y%) > 0 THEN x1% = x%: GOTO slashsizeSKIP0
  NEXT
NEXT
slashsizeSKIP0:

FOR x% = 319 TO windowx% STEP -1
  FOR y% = windowy% TO 199
    IF POINT(x%, y%) > 0 THEN x2% = x%: GOTO slashsizeSKIP1
  NEXT
NEXT
slashsizeSKIP1:

FOR y% = windowy% TO 199
  FOR x% = windowx% TO 319
    IF POINT(x%, y%) > 0 THEN y1% = y%: GOTO slashsizeSKIP2
  NEXT
NEXT
slashsizeSKIP2:

FOR y% = 199 TO windowy% STEP -1
  FOR x% = windowx% TO 319
    IF POINT(x%, y%) > 0 THEN y2% = y%: GOTO slashsizeSKIP3
  NEXT
NEXT
slashsizeSKIP3:

xsize% = x2% - x1% + 1
ysize% = y2% - y1% + 1
GET (x1%, y1%)-(x2%, y2%), image%

GOSUB getwindowxy

PUT (windowx%, windowy%), image%, PSET

GOSUB getpixelsize
GOSUB blowup

RETURN

deletecolumn:
IF xsize% = 1 THEN RETURN
GOSUB erasepaintcursor

IF cursorx% > 0 THEN
  GET (windowx%, windowy%)-(windowx% + cursorx% - 1, 199), temp2%
  PUT (windowx% + 1, windowy%), temp2%, PSET
END IF
xsize% = xsize% - 1

GOSUB getwindowxy
GOSUB getpixelsize
GOSUB getimage
GOSUB blowup
RETURN

deleterow:
IF ysize% = 1 THEN RETURN
GOSUB erasepaintcursor

IF cursory% > 0 THEN
  GET (windowx%, windowy%)-(319, windowy% + cursory% - 1), temp2%
  PUT (windowx%, windowy% + 1), temp2%, PSET
END IF
ysize% = ysize% - 1

GOSUB getwindowxy
GOSUB getpixelsize
GOSUB getimage
GOSUB blowup
RETURN

insertcolumn:
IF xsize% = 64 THEN RETURN
GOSUB erasepaintcursor

GET (windowx%, windowy%)-(windowx% + cursorx%, 199), temp2%
PUT (windowx% - 1, windowy%), temp2%, PSET
xsize% = xsize% + 1

GOSUB getwindowxy
GOSUB getpixelsize
GOSUB getimage
GOSUB blowup
RETURN

insertrow:
IF ysize% = 64 THEN RETURN
GOSUB erasepaintcursor

GET (windowx%, windowy%)-(319, windowy% + cursory%), temp2%
PUT (windowx%, windowy% - 1), temp2%, PSET

ysize% = ysize% + 1

GOSUB getwindowxy
GOSUB getpixelsize
GOSUB getimage
GOSUB blowup
RETURN

changexysize:
GOSUB erasepaintcursor: redrawpaintcursorflag% = 1
t$ = "change x y size": GOSUB showmessage

updown% = 0
GOSUB showxysizecursor

endflag% = 0
DO
  b$ = INKEY$
  IF b$ <> "" THEN GOSUB changexysizeKEYTEST
LOOP WHILE endflag% = 0

GOSUB hidexysizecursor
t$ = "change x y size": GOSUB clearmessage
RETURN

changexysizeKEYTEST:
GOSUB hidexysizecursor

IF b$ = CHR$(27) THEN endflag% = 1
IF b$ = CHR$(0) + CHR$(72) THEN updown% = 0
IF b$ = CHR$(0) + CHR$(80) THEN updown% = 1
IF b$ = CHR$(13) THEN
  GOSUB changexysizeEDITVALUE
  GOSUB updatexysizenoborder
  GOSUB expandgeneral
  GOSUB sizechangeimageadjust
  GOSUB expandgeneral2
  GOSUB drawimageborder
  GOSUB drawtinyborder
  GOSUB saveoldsubs
END IF

GOSUB showxysizecursor
RETURN

hidexysizecursor:
COLOR PANELCOLOUR
GOSUB xysizechangeDRAWLINES
RETURN

showxysizecursor:
COLOR YELLOWTEXTCOLOUR1
GOSUB xysizechangeDRAWLINES
RETURN

xysizechangeDRAWLINES:
SELECT CASE updown%
CASE 0: LINE (280, 80)-(290, 86), , B
CASE 1: LINE (280, 86)-(290, 92), , B
END SELECT
RETURN

changexysizeEDITVALUE:
pc1% = STATUSTEXTCOLOUR1
t$ = "enter value": GOSUB showmessage2
t% = xsize%
IF updown% = 1 THEN t% = ysize%
e$ = MID$(STR$(t%), 2, LEN(STR$(t%)) - 1)
px% = 282
py% = 81 + (updown% * 6)
maxchars% = 2
numberentryflag% = 1
GOSUB editstring
SELECT CASE updown%
CASE 0: xsize% = VAL(e$)
CASE 1: ysize% = VAL(e$)
END SELECT
IF (xsize% > 64) OR (ysize% > 64) THEN
  IF xsize% > 64 THEN oldxsize% = xsize%: xsize% = 64
  IF ysize% > 64 THEN oldysize% = ysize%: ysize% = 64
END IF
IF (xsize% < 1) OR (ysize% < 1) THEN
  IF xsize% < 1 THEN oldxsize% = xsize%: xsize% = 1
  IF ysize% < 1 THEN oldysize% = ysize%: ysize% = 1
END IF
t$ = "enter value": GOSUB clearmessage2
RETURN

showmessage:
x% = 258
y% = 129
c1% = YELLOWTEXTCOLOUR1
GOSUB stringdisplay
RETURN

clearmessage:
x% = 258
y% = 129
c1% = PANELCOLOUR
GOSUB stringdisplay
RETURN

showmessage2:
oldt2$ = t$
GOSUB erasememwordstatus
t$ = oldt2$
x% = 258
y% = 123
c1% = YELLOWTEXTCOLOUR1
GOSUB stringdisplay
RETURN

clearmessage2:
x% = 258
y% = 123
c1% = PANELCOLOUR
GOSUB stringdisplay
RETURN

pickfile:
GOSUB erasepaintcursor: redrawpaintcursorflag% = 1

SELECT CASE filepickmode%
CASE 0: t$ = "change filename": GOSUB showmessage
CASE 1: t$ = "save file": GOSUB showmessage
CASE 2: t$ = "load file": GOSUB showmessage
END SELECT

GOSUB showfilenamecursor

endflag% = 0
DO
  b$ = INKEY$
  IF b$ <> "" THEN GOSUB newfilenameKEYTEST
LOOP WHILE endflag% = 0

GOSUB hidefilenamecursor

SELECT CASE filepickmode%
CASE 0: t$ = "change filename": GOSUB clearmessage
CASE 1: t$ = "save file": GOSUB clearmessage
CASE 2: t$ = "load file": GOSUB clearmessage
END SELECT

RETURN

newfilenameKEYTEST:
GOSUB hidefilenamecursor

IF b$ = CHR$(27) THEN endflag% = 1
IF b$ = CHR$(0) + CHR$(72) THEN filenameupdown% = 0
IF b$ = CHR$(0) + CHR$(80) THEN filenameupdown% = 1
IF b$ = CHR$(13) THEN
  SELECT CASE filepickmode%
  CASE 0
    GOSUB newfilenameEDIT
    IF endflag2% = 1 THEN endflag% = 1
  CASE 1
    t$ = "saving...": GOSUB showmessage2
    saveerror% = 0
    SELECT CASE filenameupdown%
    CASE 0: GOSUB savebitmap
    CASE 1: GOSUB savepalette
    END SELECT
    t$ = "saving...": GOSUB clearmessage2
    IF saveerror% = 1 THEN t$ = "no filename": GOSUB delaymessage
    endflag% = 1
  CASE 2
    t$ = "loading...": GOSUB showmessage2
    SELECT CASE filenameupdown%
    CASE 0: GOSUB loadbitmap
    CASE 1: GOSUB loadpalette
    END SELECT
    endflag% = 1
    t$ = "loading...": GOSUB clearmessage2
  END SELECT
END IF

GOSUB showfilenamecursor
RETURN

hidefilenamecursor:
COLOR PANELCOLOUR
GOSUB filenamechangeDRAWLINES
GOSUB redrawpalettewordstatus
GOSUB redrawmemwordstatus
RETURN

showfilenamecursor:
COLOR YELLOWTEXTCOLOUR1
GOSUB filenamechangeDRAWLINES
RETURN

filenamechangeDRAWLINES:
SELECT CASE filenameupdown%
CASE 0: LINE (257, 104)-(318, 111), , B
CASE 1: LINE (257, 116)-(318, 123), , B
END SELECT
RETURN

newfilenameEDIT:
pc1% = BLUETEXTCOLOUR1
t$ = "enter filename": GOSUB showmessage2
px% = 258
maxchars% = 12
SELECT CASE filenameupdown%
CASE 0
  e$ = filename$
  py% = 105
  GOSUB editstring
  IF LEN(e$) = 0 THEN e$ = " "
  filename$ = e$
  GOSUB findfilemode
CASE 1
  e$ = palfilename$
  py% = 117
  GOSUB editstring
  IF LEN(e$) = 1 THEN
    e$ = "(default)"
    GOSUB editstringDRAWSTRING
  END IF
  palfilename$ = e$
END SELECT
t$ = "enter filename": GOSUB clearmessage2
RETURN

redrawpalettewordstatus:
t$ = "palette:"
x% = 258
y% = 111
c1% = STATUSTEXTCOLOUR1
GOSUB stringdisplay
RETURN

editstring:
veryolde$ = e$
cursorstate% = 1
cursorflashcountdown% = CURSORFLASHDELAY
clearflag% = 1
editstringcursorx% = 0
endflag2% = 0
GOTO editstringSKIP0
DO
  WAIT &H3DA, 8
  WAIT &H3DA, 8, 8
  IF (cursorstate% = 0 AND oldcursorstate% = 1) OR (editstringcursorx% <> oldeditstringcursorx%) OR (e$ <> olde$) THEN
    GOSUB editstringERASECURSOR
  END IF
  IF olde$ <> e$ THEN GOSUB editstringERASESTRING
editstringSKIP0:
  GOSUB editstringSAVEOLD
  c$ = INKEY$
  IF c$ <> "" THEN GOSUB editstringKEYTEST
  GOSUB editstringDRAWSTRING
  GOSUB editstringDRAWCURSOR
  GOSUB editstringFLASHCURSOR
LOOP WHILE endflag2% = 0

GOSUB editstringERASECURSOR
IF endflag2% = 2 THEN
  e$ = veryolde$
  GOSUB editstringERASESTRING
END IF
GOSUB editstringDRAWSTRING
numberentryflag% = 0
RETURN

editstringSAVEOLD:
oldeditstringcursorx% = editstringcursorx%
olde$ = e$
oldcursorstate% = cursorstate%
RETURN

editstringKEYTEST:
IF c$ = CHR$(27) THEN endflag2% = 2
IF c$ = CHR$(13) THEN
  endflag2% = 1
END IF
IF c$ = CHR$(0) + CHR$(77) THEN GOSUB editstringCURSORRIGHT: clearflag% = 0
IF c$ = CHR$(0) + CHR$(75) THEN GOSUB editstringCURSORLEFT: clearflag% = 0
IF c$ = CHR$(0) + CHR$(71) THEN GOSUB editstringHOME: clearflag% = 0
IF c$ = CHR$(0) + CHR$(79) THEN GOSUB editstringEND: clearflag% = 0
IF c$ = CHR$(0) + CHR$(115) THEN GOSUB editstringJUMPEXTENSIONLEFT: clearflag% = 0
IF c$ = CHR$(0) + CHR$(116) THEN GOSUB editstringJUMPEXTENSIONRIGHT: clearflag% = 0
IF c$ = CHR$(0) + CHR$(83) THEN GOSUB editstringDELETECHARACTER: clearflag% = 0
IF c$ = CHR$(8) THEN GOSUB editstringCURSORLEFT: GOSUB editstringDELETECHARACTER: clearflag% = 0
IF ASC(c$) >= 32 AND ASC(c$) <= 255 THEN
  IF numberentryflag% = 1 THEN
    IF ASC(c$) >= 48 AND ASC(c$) <= 57 THEN GOSUB editstringTYPETEXT
  ELSE
    GOSUB editstringTYPETEXT
  END IF
END IF
GOSUB editstringSTRINGLIMITS
GOSUB editstringCURSORLIMITS
RETURN

editstringFLASHCURSOR:
cursorflashcountdown% = cursorflashcountdown% - 1
IF cursorflashcountdown% < 0 THEN
  cursorflashcountdown% = CURSORFLASHDELAY
  cursorstate% = cursorstate% XOR 1
END IF
RETURN

editstringERASECURSOR:
SWAP editstringcursorx%, oldeditstringcursorx%: SWAP e$, olde$
GOSUB editstringGETSTRINGCURSORREALX
SWAP editstringcursorx%, oldeditstringcursorx%: SWAP e$, olde$
COLOR PANELCOLOUR
GOSUB editstringDISPLAYCURSOR
RETURN

editstringDRAWCURSOR:
IF cursorstate% = 1 THEN
  GOSUB editstringGETSTRINGCURSORREALX
  COLOR pc1%
  GOSUB editstringDISPLAYCURSOR
END IF
RETURN

editstringGETSTRINGCURSORREALX:
x% = 0
currentwidth% = 0
DEF SEG = VARSEG(fontwidth%(0))
FOR i% = 1 TO editstringcursorx% + 1
  x% = x% + currentwidth%
  IF i% > LEN(e$) THEN
    currentwidth% = 1
    x% = x% - 1
    EXIT FOR
  END IF
  char$ = MID$(e$, i%, 1)
  code% = ASC(char$)
  currentwidth% = PEEK(VARPTR(fontwidth%(0)) + code% - 32) + 1
NEXT
DEF SEG
currentwidth% = currentwidth% + 1
RETURN

editstringDISPLAYCURSOR:
LINE (px% + x%, py%)-(px% + currentwidth% - 2 + x%, py% + 5), , BF
RETURN

editstringERASESTRING:
t$ = olde$
c1% = PANELCOLOUR
GOSUB editstringDISPLAYSTRING
RETURN

editstringDRAWSTRING:
t$ = e$
c1% = pc1%
GOSUB editstringDISPLAYSTRING
RETURN

editstringDISPLAYSTRING:
x% = px%
y% = py%
GOSUB stringdisplay
RETURN

editstringCURSORRIGHT:
editstringcursorx% = editstringcursorx% + 1
RETURN

editstringCURSORLEFT:
editstringcursorx% = editstringcursorx% - 1
RETURN

editstringHOME:
editstringcursorx% = 0
RETURN

editstringEND:
editstringcursorx% = LEN(e$)
RETURN

editstringJUMPEXTENSIONRIGHT:
FOR i% = (editstringcursorx% + 1) TO LEN(e$)
  char$ = MID$(e$, i%, 1)
  IF char$ = "." THEN EXIT FOR
NEXT
editstringcursorx% = i%
RETURN

editstringJUMPEXTENSIONLEFT:
IF editstringcursorx% > 0 THEN
  IF editstringcursorx% > 1 THEN
    FOR i% = ((editstringcursorx% + 1) - 2) TO 1 STEP -1
      char$ = MID$(e$, i%, 1)
      IF char$ = "." THEN EXIT FOR
    NEXT
    editstringcursorx% = i%
  ELSE
    editstringcursorx% = 0
  END IF
END IF
RETURN

editstringHOMELIMIT:
IF editstringcursorx% < 0 THEN editstringcursorx% = 0
RETURN

editstringCURSORENDLIMIT:
IF editstringcursorx% > LEN(e$) THEN editstringcursorx% = LEN(e$)
RETURN

editstringDELETECHARACTER:
t$ = ""
IF editstringcursorx% > 0 THEN
  t$ = t$ + LEFT$(e$, editstringcursorx%)
END IF
IF editstringcursorx% < (LEN(e$) - 1) THEN
  t$ = t$ + RIGHT$(e$, LEN(e$) - editstringcursorx% - 1)
END IF
e$ = t$
RETURN

editstringCURSORLIMITS:
GOSUB editstringCURSORENDLIMIT
GOSUB editstringHOMELIMIT
RETURN

editstringSTRINGLIMITS:
IF e$ = "" THEN e$ = " "
IF (LEN(e$) > maxchars%) THEN e$ = LEFT$(e$, maxchars%)
RETURN

editstringTYPETEXT:
IF clearflag% = 1 THEN
  e$ = c$
  clearflag% = 0
ELSE
  t$ = ""
  IF editstringcursorx% > 0 THEN
    t$ = t$ + LEFT$(e$, editstringcursorx%)
  END IF
  t$ = t$ + c$
  IF editstringcursorx% < (LEN(e$) - 1) THEN
    t$ = t$ + RIGHT$(e$, LEN(e$) - editstringcursorx%)
  END IF
  e$ = t$
END IF
GOSUB editstringCURSORRIGHT
RETURN

saveoldxysize:
oldxsize% = xsize%
oldysize% = ysize%
oldoldxsize% = oldxsize%
oldoldysize% = oldysize%
RETURN

saveoldwindowxy:
oldwindowx% = windowx%
oldwindowy% = windowy%
RETURN

saveoldsubs:
GOSUB saveoldxysize
GOSUB saveoldwindowxy
RETURN

sizechangeimageadjust:
GET (oldwindowx%, oldwindowy%)-(oldwindowx% + xsize% - 1, oldwindowy% + ysize% - 1), temp2%
PUT (windowx%, windowy%), temp2%, PSET
LINE (320, 200)-(windowx% + oldoldxsize%, windowy% + oldoldysize%), 0, BF
LINE (320, windowy%)-(windowx% + oldoldxsize%, windowy% + oldoldysize%), 0, BF
LINE (windowx%, 200)-(windowx% + oldoldxsize%, windowy% + oldoldysize%), 0, BF
RETURN

adjustframe:
GOSUB erasepaintcursor
t$ = "adjust frame": GOSUB showmessage
GET (windowx%, windowy%)-(319, 199), temp3%

endflag% = 0
GOSUB adjustframeSKIP0

DO
  IF b$ <> "" THEN GOSUB adjustframeKEYTEST
adjustframeSKIP0:
  b$ = INKEY$
LOOP WHILE endflag% = 0

t$ = "adjust frame": GOSUB clearmessage
GOSUB drawpaintcursor
RETURN

adjustframeKEYTEST:
DEF SEG = 0
ab2% = PEEK(1047)
DEF SEG

SELECT CASE b$
CASE CHR$(27)
  PUT (windowx%, windowy%), temp3%, PSET
  GOSUB expandgeneral2
  endflag% = 1
CASE CHR$(13), "d": endflag% = 1
CASE CHR$(0) + CHR$(72)
  IF (ab2% AND 3) = 0 THEN
    GOSUB adjustup
  ELSE
    FOR n% = 1 TO 5: GOSUB adjustup: NEXT
  END IF
  GOSUB expandgeneral2
CASE CHR$(0) + CHR$(77)
  IF (ab2% AND 3) = 0 THEN
    GOSUB adjustright
  ELSE
    FOR n% = 1 TO 5: GOSUB adjustright: NEXT
  END IF
  GOSUB expandgeneral2
CASE CHR$(0) + CHR$(80)
  IF (ab2% AND 3) = 0 THEN
    GOSUB adjustdown
  ELSE
    FOR n% = 1 TO 5: GOSUB adjustdown: NEXT
  END IF
  GOSUB expandgeneral2
CASE CHR$(0) + CHR$(75)
  IF (ab2% AND 3) = 0 THEN
    GOSUB adjustleft
  ELSE
    FOR n% = 1 TO 5: GOSUB adjustleft: NEXT
  END IF
  GOSUB expandgeneral2
END SELECT
RETURN

adjustup:
IF ysize% > 1 THEN
  GET (windowx%, windowy% + 1)-(319, 199), temp2%
  PUT (windowx%, windowy%), temp2%, PSET
END IF
GOSUB blanklinedown
RETURN

adjustright:
IF xsize% > 1 THEN
  GET (windowx%, windowy%)-(318, 199), temp2%
  PUT (windowx% + 1, windowy%), temp2%, PSET
END IF
GOSUB blanklineleft
RETURN

adjustdown:
IF ysize% > 1 THEN
  GET (windowx%, windowy%)-(319, 198), temp2%
  PUT (windowx%, windowy% + 1), temp2%, PSET
END IF
GOSUB blanklinetop
RETURN

adjustleft:
IF xsize% > 1 THEN
  GET (windowx% + 1, windowy%)-(319, 199), temp2%
  PUT (windowx%, windowy%), temp2%, PSET
END IF
GOSUB blanklineright
RETURN

savepalette:
f$ = palfilename$
IF f$ = "(default)" THEN f$ = "default.pal"
DEF SEG = VARSEG(pal%(0))
BSAVE f$, 0, 768 + palskipbyte% * 256
DEF SEG
RETURN

savebitmap:
SELECT CASE filemode%
CASE 0: GOSUB saveimg
CASE 1: GOSUB saveimx
END SELECT
RETURN

findfilemode:
filemode% = 0
IF (LEN(filename$) >= 3) AND (LCASE$(RIGHT$(filename$, 3)) = "imx") THEN filemode% = 1
RETURN

findfilemode2:
IF filemode% = 1 THEN
  IF oldfilemode% = 0 THEN
    GOSUB clearimxmemory
    totalframes% = 0
    frame% = 0
    imx%(0) = 1
    imx%(8) = 9
  END IF
  filemode% = 1
END IF
RETURN

saveimx:
IF filename$ = " " THEN saveerror% = 1: RETURN
inc% = 0
GOSUB framechange
GOSUB getimxsize
DEF SEG = VARSEG(imx%(0))
BSAVE filename$, VARPTR(imx%(0)), imxbytesize&
DEF SEG
RETURN

saveimg:
IF filename$ = " " THEN saveerror% = 1: RETURN
GOSUB getimage
bytesperline& = image%(0) \ 8
bytesize& = (bytesperline& * image%(1)) + 4
DEF SEG = VARSEG(image%(0))
BSAVE filename$, VARPTR(image%(0)), bytesize&
DEF SEG
RETURN

erasestatusframe:
t$ = "frame:"
x% = 258
y% = 93
c1% = PANELCOLOUR
GOSUB stringdisplay
t$ = MID$(STR$(oldframe% + 1), 2, LEN(STR$(oldframe% + 1)) - 1)
t$ = t$ + "/" + MID$(STR$(oldtotalframes% + 1), 2, LEN(STR$(oldtotalframes% + 1)) - 1)
x% = 282
GOSUB stringdisplay
RETURN

loadbitmap:
SELECT CASE filemode%
CASE 0: GOSUB loadimg
CASE 1: GOSUB loadimx
END SELECT
RETURN

loadimx:
DEF SEG = VARSEG(imx%(0))
BLOAD filename$, VARPTR(imx%(0))
DEF SEG
frame% = 0
totalframes% = imx%(0) - 1
GOSUB framechangeGRABNEWFRAME
RETURN

loadimg:
DEF SEG = VARSEG(image%(0))
BLOAD filename$, 0
DEF SEG
xsize% = image%(0) \ 8
ysize% = image%(1)
GOSUB expandgeneral
PUT (windowx%, windowy%), image%, PSET
GOSUB expandgeneral2
RETURN

flipx:
t$ = "flip x": GOSUB delaymessage
GOSUB erasepaintcursor
FOR y% = 0 TO ysize% - 1
  FOR x% = 0 TO (xsize% - 1) \ 2
    c1% = POINT(windowx% + x%, windowy% + y%)
    c2% = POINT(319 - x%, windowy% + y%)
    PSET (windowx% + x%, windowy% + y%), c2%
    PSET (319 - x%, windowy% + y%), c1%
  NEXT
NEXT
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

flipy:
t$ = "flip y": GOSUB delaymessage
GOSUB erasepaintcursor
FOR x% = 0 TO xsize% - 1
  FOR y% = 0 TO (ysize% - 1) \ 2
    c1% = POINT(windowx% + x%, windowy% + y%)
    c2% = POINT(windowx% + x%, 199 - y%)
    PSET (windowx% + x%, windowy% + y%), c2%
    PSET (windowx% + x%, 199 - y%), c1%
  NEXT
NEXT
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

rotate90:
t$ = "rotate 90": GOSUB delaymessage
GOSUB erasepaintcursor
bigger% = xsize%
IF ysize% > bigger% THEN bigger% = ysize%
IF xsize% = bigger% THEN
    smaller% = ysize%
    startx% = INT((bigger% - smaller%) / 2)
    starty% = 0
END IF
IF ysize% = bigger% THEN
    smaller% = xsize%
    startx% = 0
    starty% = INT((bigger% - smaller%) / 2)
END IF
tempxsize% = smaller%
tempysize% = smaller%
i% = 0
FOR y% = 0 TO tempysize% - 1
    FOR x% = 0 TO tempxsize% - 1
        temp2%(i%) = POINT(windowx% + x% + startx%, windowy% + y% + starty%)
        i% = i% + 1
    NEXT
NEXT
i% = 0
FOR x% = tempxsize% - 1 TO 0 STEP -1
    FOR y% = 0 TO tempysize% - 1
        PSET (windowx% + x% + startx%, windowy% + y% + starty%), temp2%(i%)
        i% = i% + 1
    NEXT
NEXT
LINE (windowx% - 1, windowy% - 1)-(windowx% + startx% - 1, 200), 0, BF
LINE (windowx% - 1, windowy% - 1)-(320, windowy% + starty% - 1), 0, BF
LINE (windowx% + startx% + tempxsize%, windowy% - 1)-(320, 200), 0, BF
LINE (windowx% - 1, windowy% + starty% + tempysize%)-(320, 200), 0, BF

GOSUB expandgeneral2
redrawpaintcursorflag% = 1
GOSUB drawtinyborder

RETURN

delaymessage:
oldt$ = t$
IF delaymessagecountdown% > 0 THEN GOSUB cleardelaymessage
delaymessage$ = t$
delaymessagecountdown% = 0
GOSUB showmessage2
delaymessagecountdown% = DELAYMESSAGEORIGINALCOUNTDOWN
RETURN
   
dodelaymessage:
IF delaymessagecountdown% > 0 THEN
  delaymessagecountdown% = delaymessagecountdown% - 1
  IF delaymessagecountdown% <= 0 THEN GOSUB cleardelaymessage
END IF
RETURN

cleardelaymessage:
t$ = delaymessage$
GOSUB clearmessage2
GOSUB drawmemwordstatus
RETURN

copy:
GOSUB erasepaintcursor
t$ = "copy": GOSUB delaymessage
i% = 0
FOR y% = windowy% TO 199
  FOR x% = windowx% TO 319
    temp%(i%) = POINT(x%, y%)
    i% = i% + 1
  NEXT
NEXT
tempframexsize% = xsize%
tempframeysize% = ysize%
redrawpaintcursorflag% = 1
RETURN

paste:
t$ = "insert": GOSUB delaymessage
GOSUB erasepaintcursor
i% = 0
offset% = 0
xtotal% = tempframexsize%
ytotal% = tempframeysize%
IF xsize% < xtotal% THEN xtotal% = xsize%: offset% = tempframexsize% - xsize%
IF ysize% < ytotal% THEN ytotal% = ysize%

FOR y% = 0 TO ytotal% - 1
  FOR x% = 0 TO xtotal% - 1
    PSET (windowx% + x%, windowy% + y%), temp%(i%)
    i% = i% + 1
  NEXT
  i% = i% + offset%
NEXT

GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

pasteover:
t$ = "insert over": GOSUB delaymessage
GOSUB erasepaintcursor
i% = 0
offset% = 0
xtotal% = tempframexsize%
ytotal% = tempframeysize%
IF xsize% < xtotal% THEN xtotal% = xsize%: offset% = tempframexsize% - xsize%
IF ysize% < ytotal% THEN ytotal% = ysize%

FOR y% = 0 TO ytotal% - 1
  FOR x% = 0 TO xtotal% - 1
    IF temp%(i%) > 0 THEN PSET (windowx% + x%, windowy% + y%), temp%(i%)
    i% = i% + 1
  NEXT
  i% = i% + offset%
NEXT

GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

pasteunder:
t$ = "insert under": GOSUB delaymessage
GOSUB erasepaintcursor
i% = 0
offset% = 0
xtotal% = tempframexsize%
ytotal% = tempframeysize%
IF xsize% < xtotal% THEN xtotal% = xsize%: offset% = tempframexsize% - xsize%
IF ysize% < ytotal% THEN ytotal% = ysize%

FOR y% = 0 TO ytotal% - 1
  FOR x% = 0 TO xtotal% - 1
    IF POINT(windowx% + x%, windowy% + y%) = 0 THEN PSET (windowx% + x%, windowy% + y%), temp%(i%)
    i% = i% + 1
  NEXT
  i% = i% + offset%
NEXT

GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

clearframe:
GOSUB erasepaintcursor
t$ = "clear frame?": GOSUB showmessage2
t$ = "ENTER = YES": GOSUB showmessage
DO: b$ = INKEY$: LOOP WHILE b$ = ""
IF b$ = CHR$(13) THEN
  GOSUB clearframenoask
END IF
t$ = "clear frame?": GOSUB clearmessage2
t$ = "ENTER = YES": GOSUB clearmessage
redrawpaintcursorflag% = 1
RETURN

clearframenoask:
LINE (windowx%, windowy%)-(319, 199), 0, BF
GOSUB expandgeneral2
RETURN

floodfill:
t$ = "flood fill": GOSUB showmessage2
GOSUB erasepaintcursor

px% = cursorx% + windowx%
py% = cursory% + windowy%
paintcolour% = colour%

bgcolour% = POINT(px%, py%)
IF bgcolour% = paintcolour% THEN GOTO superpaintSKIP0

GOSUB superpaintCLEARTEMP2

x% = px%
y% = py%
stackpointer% = 0
DO WHILE stackpointer% >= 0
superpaintLOOP0:
  IF x% <= 319 AND y% <= 199 AND x% >= windowx% AND y% >= windowy% THEN
    GOSUB superpaintDRAWPIXEL
    IF POINT(x%, y% - 1) = bgcolour% AND (y% - 1) >= windowy% AND imgpixel2%(x% - windowx%, y% - windowy% - 1) = 0 THEN GOSUB superpaintPUSH: y% = y% - 1: GOTO superpaintLOOP0
    IF POINT(x% + 1, y%) = bgcolour% AND (x% + 1) <= 319 AND imgpixel2%(x% - windowx% + 1, y% - windowy%) = 0 THEN GOSUB superpaintPUSH: x% = x% + 1: GOTO superpaintLOOP0
    IF POINT(x%, y% + 1) = bgcolour% AND (y% + 1) <= 199 AND imgpixel2%(x% - windowx%, y% - windowy% + 1) = 0 THEN GOSUB superpaintPUSH: y% = y% + 1: GOTO superpaintLOOP0
    IF POINT(x% - 1, y%) = bgcolour% AND (x% - 1) >= windowx% AND imgpixel2%(x% - windowx% - 1, y% - windowy%) = 0 THEN GOSUB superpaintPUSH: x% = x% - 1: GOTO superpaintLOOP0
  END IF
  GOSUB superpaintPOP
LOOP
superpaintSKIP0:
t$ = "flood fill": GOSUB clearmessage2
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

superpaintPUSH:
stackx%(stackpointer%) = x%
stacky%(stackpointer%) = y%
stackpointer% = stackpointer% + 1
RETURN

superpaintPOP:
stackpointer% = stackpointer% - 1
IF stackpointer% >= 0 THEN
  x% = stackx%(stackpointer%)
  y% = stacky%(stackpointer%)
END IF
RETURN

superpaintDRAWPIXEL:
temp2%((y% - windowy%) * xsize% + (x% - windowx%)) = 1
PSET (x%, y%), paintcolour%
RETURN

superpaintCLEARTEMP2:
i& = 0
FOR y% = 0 TO ysize% - 1
  FOR x% = 0 TO xsize% - 1
    temp2%(i&) = 0
    i& = i& + 1
  NEXT
NEXT
RETURN

qbpaint:
t$ = "qb paint": GOSUB delaymessage
GOSUB erasepaintcursor
LINE (windowx% - 1, windowy% - 1)-(320, 200), ecolour%, B
PAINT (windowx% + cursorx%, windowy% + cursory%), colour%, ecolour%
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
GOSUB drawpanelborders
GOSUB drawtinyborder
RETURN

drawpanelborders:
LINE (0, 136)-(255, 199), BORDERCOLOUR, B
LINE (256, 68)-(319, 135), BORDERCOLOUR, B
RETURN

colours:
t$ = "colours": GOSUB delaymessage
GOSUB erasepaintcursor
FOR x% = windowx% TO 319
  FOR y% = windowy% TO 199
    IF POINT(x%, y%) = ecolour% THEN PSET (x%, y%), colour%
  NEXT
NEXT
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

nfunction:
IF (tempframexsize% = 0) OR (tempframeysize% = 0) THEN RETURN
GOSUB erasepaintcursor
x% = cursorx%
y% = cursory%
IF a$ = "w" THEN
  x% = x% MOD tempframexsize%
  y% = y% MOD tempframeysize%
END IF
IF (x% < tempframexsize%) AND (y% < tempframeysize%) THEN
  index% = (y% * tempframexsize%) + x%
  c% = temp%(index%)
  GOSUB drawpixel
END IF

redrawpaintcursorflag% = 1
RETURN

setspread:
GOSUB erasepaintcursor

oldoldcolour% = colour%
oldoldecolour% = ecolour%
oldoldred% = oldred%: oldoldgreen% = oldgreen%: oldoldblue% = oldblue%

t$ = "set spread": GOSUB showmessage2
t$ = "colour 1": GOSUB showmessage

colourflag% = 0
endflag% = 0

DO
  b$ = INKEY$
  DEF SEG = 0: ab% = PEEK(1047): DEF SEG
  IF b$ <> "" THEN GOSUB setspreadkeytest
LOOP WHILE endflag% = 0

t$ = "set spread": GOSUB clearmessage2
SELECT CASE colourflag%
CASE 0: t$ = "colour 1": GOSUB clearmessage
CASE 1: t$ = "colour 2": GOSUB clearmessage
END SELECT

redrawpaintcursorflag% = 1
RETURN

setspreadkeytest:
GOSUB updatecolourssaveold
SWAP a$, b$
GOSUB colourcontrol
SWAP a$, b$
colour% = colour% AND 255
GOSUB updatecoloursnocheck
IF b$ = CHR$(27) THEN endflag% = 1
IF b$ = CHR$(13) THEN
  SELECT CASE colourflag%
  CASE 0
    colourflag% = 1
    cc1% = colour%
    t$ = "colour 1": GOSUB clearmessage
    t$ = "colour 2": GOSUB showmessage
  CASE 1
    endflag% = 1
    cc2% = colour%
    GOSUB setspreadREALLYSETSPREAD
  END SELECT
END IF
RETURN

colourcontrol:
IF a$ = "+" THEN
  IF (ab% AND 3) = 0 THEN
    colour% = colour% + 1
  ELSE
    colour% = colour% + 16
  END IF
END IF
IF a$ = "-" THEN
  IF (ab% AND 3) = 0 THEN
    colour% = colour% - 1
  ELSE
    colour% = colour% - 16
  END IF
END IF
RETURN

setspreadREALLYSETSPREAD:
c1% = cc1%
c2% = cc2%
IF c1% = c2% THEN RETURN
IF c1% > c2% THEN SWAP c1%, c2%
DEF SEG = VARSEG(pal%(0))
r1% = PEEK((c1% * 3))
g1% = PEEK((c1% * 3) + 1)
b1% = PEEK((c1% * 3) + 2)
r2% = PEEK((c2% * 3))
g2% = PEEK((c2% * 3) + 1)
b2% = PEEK((c2% * 3) + 2)
DEF SEG
rdelta = (r2% - r1%) / (c2% - c1%)
gdelta = (g2% - g1%) / (c2% - c1%)
bdelta = (b2% - b1%) / (c2% - c1%)
r = r1%
g = g1%
b = b1%
FOR c% = (c1% + 1) TO c2%
  r = r + rdelta
  g = g + gdelta
  b = b + bdelta
  red% = r
  green% = g
  blue% = b
  GOSUB changergb
NEXT
RETURN

darkencolour:
red% = red% - ((16 / (red% + 1)) + 1)
green% = green% - ((16 / (green% + 1)) + 1)
blue% = blue% - ((16 / (blue% + 1)) + 1)
IF red% < 0 THEN red% = 0
IF green% < 0 THEN green% = 0
IF blue% < 0 THEN blue% = 0
RETURN

lightencolour:
red% = red% + ((16 / (red% + 1)) + 1)
green% = green% + ((16 / (green% + 1)) + 1)
blue% = blue% + ((16 / (blue% + 1)) + 1)
IF red% > 63 THEN red% = 63
IF green% > 63 THEN green% = 63
IF blue% > 63 THEN blue% = 63
RETURN

updatecoloursnocheck:
GOSUB updatecolourboxes
GOSUB erasecolorcursor
GOSUB drawcolorcursor
RETURN

updatecolourssaveold:
oldcolour% = colour%
oldred% = red%
oldgreen% = green%
oldblue% = blue%
RETURN

getimxsize:
imxbytesize& = 16 + (imx%(0) * 2)
FOR i% = 0 TO imx%(0) - 1
  i2% = imx%(i% + 8)
  x% = imx%(i2%) \ 8
  y% = imx%(i2% + 1)
  bytesize& = (x% * y%) + 4
  IF (bytesize& AND 1) THEN bytesize& = bytesize& + 1
  imxbytesize& = imxbytesize& + bytesize&
NEXT
RETURN

framechange:
GOSUB erasepaintcursor
frame% = frame% + inc%
IF frame% < 0 THEN frame% = totalframes%
IF frame% > totalframes% THEN frame% = 0
GOSUB framechangeUPDATEOLDFRAME
GOSUB framechangeGRABNEWFRAME
RETURN

addframe:
GOSUB framechangeUPDATEOLDFRAME
pframe% = frame% + inc%
pxsize% = xsize%
pysize% = ysize%
GOSUB imxinsertframe
IF nomemoryerrorflag% = 1 THEN RETURN
pframe% = frame% + inc%
GOSUB imxclearframe
frame% = frame% + inc%
GOSUB framechangeGRABNEWFRAME
RETURN

delframe:
IF (totalframes% = 0) THEN GOSUB clearframenoask: RETURN
pframe% = frame%
GOSUB imxdelframe
IF frame% > totalframes% THEN frame% = totalframes%
GOSUB framechangeGRABNEWFRAME
RETURN

framechangeUPDATEOLDFRAME:
GOSUB updateoldframeCHECKOK
pframe% = oldframe%
GOSUB imxdelframe
pxsize% = xsize%
pysize% = ysize%
GOSUB imxinsertframe
GOSUB framechangeCOPYIMAGETOIMX
RETURN

imxdelframe:
IF totalframes% = -1 THEN RETURN

'Get offset of imx frame to be deleted before imx lookup table is contracted
destinationoffset1& = imx%(8 + pframe%) - 1
x% = imx%(imx%(8 + pframe%)) \ 8
y% = imx%(imx%(8 + pframe%) + 1)
poffset& = (imx%(8) * 2) + VARPTR(imx%(0))

'step 1: Contract imx lookup table
IF pframe% < totalframes% THEN
  FOR i% = pframe% + 1 TO totalframes%
    imx%((i% - 1) + 8) = imx%(i% + 8)
  NEXT
END IF

'step 3: Move imx frames backward 2 bytes
numberbytes& = IMXWORDSIZE
numberbytes& = numberbytes& * 2
numberbytes& = numberbytes& - poffset&
DEF SEG = VARSEG(movememrtn%(0))
CALL absolute(VARSEG(imx%(0)), poffset&, VARSEG(imx%(0)), poffset& - 2, numberbytes&, 0)
DEF SEG

'step 4: Eliminate frame to be deleted from imx frames
destinationoffset1& = destinationoffset1& * 2 'Address of frame to be deleted

bytesize& = (x% * y%) + 4

'Make sure byte size is even
IF (bytesize& AND 1) = 1 THEN bytesize& = bytesize& + 1

sourceoffset1& = destinationoffset1& + bytesize&

numberbytes& = IMXWORDSIZE

numberbytes& = numberbytes& * 2

numberbytes& = numberbytes& - sourceoffset1&

DEF SEG = VARSEG(movememrtn%(0))
CALL absolute(VARSEG(imx%(0)), sourceoffset1&, VARSEG(imx%(0)), destinationoffset1&, numberbytes&, 0)
DEF SEG

'step 2: Subtract 2 from imx lookup table entries
FOR i% = 0 TO totalframes% - 1
  imx%(i% + 8) = imx%(i% + 8) - 1
NEXT

'step 5: Update imx lookup table entries to reflect elimination of frame
bytesize& = sourceoffset1& - destinationoffset1&
relativeindex% = bytesize& \ 2
FOR i% = pframe% TO totalframes% - 1
  imx%(i% + 8) = imx%(i% + 8) - relativeindex%
NEXT

'There's one less frame now
totalframes% = totalframes% - 1

'Step 7: Update imx header
imx%(0) = totalframes% + 1

RETURN

imxinsertframe:
GOSUB erasepaintcursor

'Step 1 a: find out how many bytes to insert
bytestoinsert& = (pxsize% * pysize%) + 4
'Make sure number of bytes to insert is an even number
IF (bytestoinsert& AND 1) = 1 THEN bytestoinsert& = bytestoinsert& + 1

'Step 1 b: insert bytes
sourceoffset1& = imx%(8 + pframe%)
IF (pframe% = 0) AND (totalframes% = -1) THEN
  sourceoffset1& = 8
ELSE
  IF (pframe% > totalframes%) THEN
    'Determine soureoffet1& here:
    sourceoffset1& = (totalframes% + 1) + 8
    FOR i% = 0 TO totalframes%
      xs% = imx%(imx%(8 + i%)) \ 8
      ys% = imx%(imx%(8 + i%) + 1)
      bytes& = (ys% * xs%) + 4
      IF (bytes& AND 1) = 1 THEN bytes& = bytes& + 1
      sourceoffset1& = sourceoffset1& + (bytes& \ 2)
    NEXT
  END IF
END IF
sourceoffset1& = sourceoffset1& * 2
destinationoffset1& = sourceoffset1& + bytestoinsert&
numberbytes& = IMXWORDSIZE
numberbytes& = numberbytes& * 2
numberbytes& = numberbytes& - destinationoffset1&
finaloffset& = imx%(8 + totalframes%)
finaloffset& = finaloffset& * 2
xs% = imx%(imx%(8 + totalframes%)) \ 8
ys% = imx%(imx%(8 + totalframes%) + 1)
finaloffset& = finaloffset& + (xs% * ys%) + 4
nomemoryerrorflag% = 0
IF ((finaloffset& + bytestoinsert&) \ 2) > (IMXWORDSIZE) THEN
  nomemoryerrorflag% = 1
  t$ = "out of memory"
  GOSUB delaymessage
  RETURN
END IF
DEF SEG = VARSEG(movememrtn%(0))
CALL absolute(VARSEG(imx%(0)), sourceoffset1&, VARSEG(imx%(0)), destinationoffset1&, numberbytes&, 0)
DEF SEG

'Step 2: move imx frames bytes over 2 bytes to the right
IF (totalframes% = -1) AND (pframe% = 0) THEN
  sourceoffset2& = 8
ELSE
  sourceoffset2& = imx%(8)
END IF

sourceoffset2& = sourceoffset2& * 2
destinationoffset2& = sourceoffset2& + 2
numberbytes& = IMXWORDSIZE
numberbytes& = numberbytes& * 2
numberbytes& = numberbytes& - destinationoffset2&
DEF SEG = VARSEG(movememrtn%(0))
CALL absolute(VARSEG(imx%(0)), sourceoffset2&, VARSEG(imx%(0)), destinationoffset2&, numberbytes&, 0)
DEF SEG

'Step 3: make room for lookup table entry for new frame
bytesize& = destinationoffset1& - sourceoffset1&
relativeindex% = bytesize& \ 2
FOR i% = totalframes% TO pframe% STEP -1
  imx%(8 + i% + 1) = imx%(8 + i%) + relativeindex%
NEXT

'Step 3 a: add 2 to all lookup table entries
FOR i% = 0 TO totalframes% + 1
  '+2 because frames were moved
  imx%(8 + i%) = imx%(8 + i%) + 1
NEXT

'Step 4: insert lookup entry frame
newindex% = (sourceoffset1& \ 2) + 1
imx%(8 + pframe%) = newindex%

'Step 5: update imx header
totalframes% = totalframes% + 1
imx%(0) = totalframes% + 1

'Step 6: update x and y size in imx frame
imx%(newindex%) = pxsize% * 8
imx%(newindex% + 1) = pysize%

redrawpaintcursorflag% = 1
RETURN

framechangeCOPYIMAGETOIMX:
numberbytes& = (pysize% * pxsize%) + 4
destinationoffset1& = imx%(8 + pframe%)
destinationoffset1& = destinationoffset1& * 2
DEF SEG = VARSEG(movememrtn%(0))
CALL absolute(VARSEG(image%(0)), VARPTR(image%(0)), VARSEG(imx%(0)), destinationoffset1&, numberbytes&, 0)
DEF SEG
RETURN

framechangeGRABNEWFRAME:
i% = imx%(8 + frame%)
xsize% = imx%(i%) \ 8
ysize% = imx%(i% + 1)
bytesize& = (xsize% * ysize%) + 4
sourceoffset1& = i%
sourceoffset1& = sourceoffset1& * 2
DEF SEG = VARSEG(movememrtn%(0))
CALL absolute(VARSEG(imx%(0)), sourceoffset1&, VARSEG(image%(0)), VARPTR(image%(0)), bytesize&, 0)
DEF SEG
GOSUB updatexysizenoborder
GOSUB expandgeneral
PUT (windowx%, windowy%), image%, PSET
GOSUB expandgeneral2
GOSUB drawimageborder
GOSUB drawtinyborder
redrawpaintcursorflag% = 1
RETURN

imxclearframe:
numberbytes& = (pxsize% * pysize%)
IF (numberbytes& AND 1) = 1 THEN numberbytes& = numberbytes& + 1
numberwords% = numberbytes& \ 2
i% = imx%(8 + pframe%) + 2
FOR n% = i% TO i% + numberwords% - 1
  imx%(n%) = 0
NEXT
RETURN

clearimxmemory:
DEF SEG = VARSEG(memfillrtn%(0))
numberbytes& = IMXWORDSIZE
numberbytes& = numberbytes& * 2
CALL absolute(VARSEG(imx%(0)), VARPTR(imx%(0)), 0, numberbytes&, 0)
DEF SEG
RETURN

nextcommandpage:
commandpage% = commandpage% + 1
IF commandpage% > MAXCOMMANDPAGE THEN commandpage% = 0
GOSUB drawcommandpage
RETURN

previouscommandpage:
commandpage% = commandpage% - 1
IF commandpage% < 0 THEN commandpage% = MAXCOMMANDPAGE
GOSUB drawcommandpage
RETURN

drawcommandpage:
LINE (1, 137)-(254, 198), PANELCOLOUR, BF
c1% = BLUETEXTCOLOUR1
c2% = PANELCOLOUR
SELECT CASE commandpage%
CASE 0
  x% = 2
  y% = 137
  sd "space = draw"
  sd "b = draw"
  sd "+ = colour plus 1"
  sd "- = colour minus 1"
  sd "shift + = colour plus 16"
  sd "shift - = colour minus 16"
  sd "f = change filename"
  sd "z = change image size"
  sd "e = erase"
  sd "` = erase with colour 0"
  x% = 128
  y% = 137
  sd "c = copy"
  sd "i = paste"
  sd "left shift i = paste over"
  sd "right shift i = paste under"
  sd "r = flip x"
  sd "left shift r = flip y"
  sd "right shift r = rotate 90"
  sd "x = swap erase & draw colour"
  sd "/ = grab colour under cursor"
  sd "? = grab erase colour at cursor"
CASE 1
  x% = 2
  y% = 137
  sd "d = adjust xy location"
  sd "n = put dot from tmp"       '<- invented by Lukas Sedlacek
  sd "w = align temp to tile"
  sd "a = toggle auto draw"
  sd "home = align cursor to left edge"
  sd "end = align cursor to right edge"
  sd "shift home = align cursor top"
  sd "shift end = align cursor bottom"
  sd "ctrl home = go top left corner"
  sd "ctrl end = bottom right corner"
  y% = 137
  x% = 128
  sd "l = load frames"
  sd "s = save frames"
  sd "ESC ESC = exit"
  sd "7 = red minus 1"
  sd "9 = red plus 1"
  sd "4 = green minus 1"
  sd "6 = green plus 1"
  sd "1 = blue minus 1"
  sd "3 = blue plus 1"
  sd "5 = set spread (ENTER picks clr)"
CASE 2
  x% = 2
  y% = 137
  sd "shift f = flood fill"
  sd "p = qb paint (ecolour = border)"
  sd "shift c = change colours in frame"
  sd "          from ecolour to colour"
  sd "shift n = clear frame"
  sd "\ = remove border around frame"
  sd "8 = make colour brighter"
  sd "2 = make colour darker"
  sd "insert = insert column"
  sd "delete = delete column"
  x% = 138
  y% = 143
  sd "shift insert = insert row"
  sd "shift delete = delete row"
  sd "] = all colours of image + 1"
  sd "[ = all colours of image - 1"
  sd "} = all colours of image + 16"
  sd "{ = all colours of image - 16"
  sd "note: except colour 0"
  sd "shift+x = erase colour = colour"
  sd "o = outline"
CASE 3
  x% = 2
  y% = 137
  sd "m = generate mask"
CASE 4
  x% = 2
  y% = 137
  sd "frame control in *.imx mode  (file .imx)"
  sd "F5 = insert blank frame after current frame"
  sd "shift F5 = insert blank frame at current frame"
  sd "F6 = delete current frame"
  sd "page up = next frame"
  sd "page down = previous frame"
  sd "shift page up = frame plus 5"
  sd "shift page down = frame minus 5"
  sd "ctrl page up = goto first frame"
  sd "ctrl page down = goto last frame"
CASE 5
  x% = 2
  y% = 137
  sd "loading an img"
  sd "------------"
  sd ""
  sd "CLS: SCREEN 13"
  sd "DIM image%(size%)"
  sd "DEF SEG = VARSEG(image%(0))"
  sd "BLOAD filename$, 0"
  sd "DEF SEG"
  sd ""
  sd "PUT (x%, y%), image%"
  x% = 110
  y% = 137
  sd "loading an imx"
  sd "------------"
  sd ""
  sd "CLS: SCREEN 13"
  sd "DIM imx%(size%)"
  sd "DEF SEG = VARSEG(imx%(0))"
  sd "BLOAD filename$, 0"
  sd "DEF SEG"
  sd ""
  sd "PUT (x%, y%), imx%(imx%(8 + frame%))"
CASE 6
  x% = 2
  y% = 137
  sd "loading a pal"
  sd "------------"
  sd ""
  sd "CLS: SCREEN 13: DIM pal%(512)"
  sd "DEF SEG = VARSEG(pal%(0))"
  sd "BLOAD palfile$, 0"
  sd "i% = 0: FOR c% = 0 to 255"
  sd "OUT &H3c8, c%: OUT &H3c9, PEEK(i%)"
  sd "OUT &H3c9, PEEK(i% + 1): OUT &H3c9, PEEK(i% + 2)"
  sd "i% = i% + 3: NEXT: DEF SEG"
CASE 7
  x% = 2
  y% = 137
  sd "cool moves:"
  sd ""
  sd "Go to an edge, hold shift and press in"
  sd "the direction of the edge."
  sd ""
  sd "Go to an edge, hold shift and press away"
  sd "from the edge."
END SELECT

x% = 190
y% = 137
sd "page" + STR$(commandpage% + 1) + "/" + MID$(STR$(MAXCOMMANDPAGE + 1), 2, LEN(STR$(MAXCOMMANDPAGE + 1)) - 1) + " F1=next"


RETURN

altdraw:
oldalt% = alt%
alt% = (ab% AND 8) \ 8
IF (alt% = 1 AND oldalt% = 0) THEN
  c% = colour%
  GOSUB drawpixel
  GOSUB drawpaintcursor
END IF
RETURN

coloursadjust:
GOSUB erasepaintcursor
FOR y% = windowy% TO 199
  FOR x% = windowx% TO 319
    c% = POINT(x%, y%)
    IF c% <> 0 THEN c% = (c% + inc%) AND 255: PSET (x%, y%), c%
  NEXT
NEXT
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

updateoldframeCHECKOK:

'Determine number of bytes in old image
'Determine number of bytes in new image

pframe% = oldframe%

RETURN

redrawmemwordstatus:
GOSUB erasememwordstatus
GOSUB drawmemwordstatus
RETURN

erasememwordstatus:
IF delaymessagecountdown% <= 0 THEN
  t$ = "mem:" + MID$(STR$(oldimxbytesize&), 2, LEN(STR$(oldimxbytesize&)) - 1) + "/" + MID$(STR$(totalmem&), 2, LEN(STR$(totalmem&)) - 1)
  x% = 258
  y% = 123
  c1% = PANELCOLOUR
  c2% = PANELCOLOUR
  GOSUB stringdisplay
END IF
RETURN

drawmemwordstatus:
GOSUB getimxsizecurrent
IF delaymessagecountdown% <= 0 THEN
  t$ = "mem:" + MID$(STR$(imxbytesize&), 2, LEN(STR$(imxbytesize&)) - 1) + "/" + MID$(STR$(totalmem&), 2, LEN(STR$(totalmem&)) - 1)
  x% = 258
  y% = 123
  c1% = STATUSTEXTCOLOUR1
  GOSUB stringdisplay
  oldimxbytesize& = imxbytesize&
END IF
RETURN

getimxsizecurrent:
bytes& = (xsize% * ysize%) + 4
imxbytesize& = 0
IF filemode% = 1 THEN
  imxbytesize& = 16 + (imx%(0) * 2)
  FOR i% = 0 TO imx%(0) - 1
    IF i% <> frame% THEN
      i2% = imx%(i% + 8)
      x% = imx%(i2%) \ 8
      y% = imx%(i2% + 1)
      bytesize& = (x% * y%) + 4
      IF (bytesize& AND 1) THEN bytesize& = bytesize& + 1
      imxbytesize& = imxbytesize& + bytesize&
    END IF
  NEXT
  IF (bytes& AND 1) THEN bytes& = bytes& + 1
END IF
imxbytesize& = imxbytesize& + bytes&
RETURN

initvariables:
totalmem& = IMXWORDSIZE
totalmem& = totalmem& * 2
RETURN

outline:
t$ = "outline": GOSUB delaymessage
GOSUB erasepaintcursor
i% = 0
FOR y% = 0 TO ysize% - 1
  FOR x% = 0 TO xsize% - 1
    temp2%(i%) = POINT(windowx% + x%, windowy% + y%)
    i% = i% + 1
  NEXT
NEXT
FOR y% = 0 TO ysize% - 1
  FOR x% = 0 TO xsize% - 1
    c% = POINT(windowx% + x%, windowy% + y%)
    IF c% = 0 THEN
      IF y% > 0 THEN c% = c% + temp2%((y% - 1) * xsize% + x%)
      IF x% < xsize% - 1 THEN c% = c% + temp2%(y% * xsize% + x% + 1)
      IF y% < ysize% - 1 THEN c% = c% + temp2%((y% + 1) * xsize% + x%)
      IF x% > 0 THEN c% = c% + temp2%(y% * xsize% + x% - 1)
      IF c% > 0 THEN PSET (windowx% + x%, windowy% + y%), colour%
    END IF
  NEXT
NEXT
GOSUB expandgeneral2
redrawpaintcursorflag% = 1
RETURN

makemask:
GOSUB erasepaintcursor
t$ = "make mask?": GOSUB showmessage2
t$ = "ENTER = YES": GOSUB showmessage
DO: b$ = INKEY$: LOOP WHILE b$ = ""
IF b$ = CHR$(13) THEN
  FOR y% = 0 TO ysize% - 1
    FOR x% = 0 TO xsize% - 1
      c% = POINT(x% + windowx%, y% + windowy%)
      IF c% = 0 THEN
        c% = 255
      ELSE
        c% = 0
      END IF
      PSET (x% + windowx%, y% + windowy%), c%
    NEXT
  NEXT
END IF
t$ = "make mask?": GOSUB clearmessage2
t$ = "ENTER = YES": GOSUB clearmessage
redrawpaintcursorflag% = 1
GOSUB expandgeneral2
RETURN

FUNCTION imgpixel2% (ppx%, ppy%)
IF ppx% < 0 OR ppy% < 0 THEN imgpixel2% = 0: EXIT FUNCTION
px% = ppx%
py% = ppy%
px% = px% MOD xsize%
py% = py% MOD ysize%
imgpixel2% = temp2%(py% * xsize% + px%)
END FUNCTION

SUB sd (t$)
IF t$ <> "" THEN
DIM tempstring AS STRING * 80
xx% = x%
yy% = y%
cc1% = c1%
tempstring = t$
tempstringlength% = LEN(t$)
DEF SEG = VARSEG(string13%(0))
CALL absolute(1, VARSEG(font%(0)), VARPTR(font%(0)), VARSEG(tempstring), VARPTR(tempstring), tempstringlength%, xx%, yy%, cc1%, 0, VARSEG(fontwidth%(0)), VARPTR(fontwidth%(0)), &H10)
DEF SEG
END IF
y% = y% + 6
END SUB

